import { UnknownValuePlotting_$type } from "@infragistics/igniteui-react-core";
import { IgrAnchoredRadialSeries } from "./igr-anchored-radial-series";
import { RadialAreaSeries } from "./RadialAreaSeries";
import { ensureEnum } from "@infragistics/igniteui-react-core";
/**
 * Represents a IgxDataChartComponent radial area series.
*/
export class IgrRadialAreaSeries extends IgrAnchoredRadialSeries {
    createImplementation() {
        return new RadialAreaSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    /**
     * Gets whether the current series shows an area shape.
    */
    get isArea() {
        return this.i.df;
    }
    /**
     * Determines how unknown values will be plotted on the chart.
     * Null and Double.NaN are two examples of unknown values.
    */
    get unknownValuePlotting() {
        return this.i.ug;
    }
    set unknownValuePlotting(v) {
        this.i.ug = ensureEnum(UnknownValuePlotting_$type, v);
    }
}
