import { __extends } from "tslib";
import { IgrSplineSeriesBase } from "./igr-spline-series-base";
import { toPoint, fromPoint } from "@infragistics/igniteui-react-core";
/**
 * Represents one part in a StackedSplineSeries or StackedSplineAreaSeries.
*/
var IgrSplineFragmentBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrSplineFragmentBase, _super);
    function IgrSplineFragmentBase(props) {
        return _super.call(this, props) || this;
    }
    Object.defineProperty(IgrSplineFragmentBase.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrSplineFragmentBase.prototype, "isFragment", {
        /**
         * Gets whether the current series is a stack fragment.
        */
        get: function () {
            return this.i.dx;
        },
        enumerable: false,
        configurable: true
    });
    IgrSplineFragmentBase.prototype.getSeriesValuePosition = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.ps(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    };
    return IgrSplineFragmentBase;
}(IgrSplineSeriesBase));
export { IgrSplineFragmentBase };
