import { Type } from "@infragistics/igniteui-react-core";
/**
 * Describes actual shape of legend badge that represents a series in a legend
 */
export declare enum ActualLegendItemBadgeShape {
    /**
     * Specifies a circle shape in a legend
     */
    CircleShape = 0,
    /**
     * Specifies a thin line with overlaid marker in a legend
     */
    LineWithMarker = 1,
    /**
     * Specifies a thin line without overlaid marker in a legend
     */
    LineMarkerless = 2,
    /**
     * Specifies a thick horizontal bar shape in a legend
     */
    BarShape = 3,
    /**
     * Specifies a thick vertical column shape in a legend
     */
    ColumnShape = 4,
    /**
     * Specifies standard square shape in a legend
     */
    SquareShape = 5,
    /**
     * Specifies financial square shape in a legend
     */
    SquareFinancial = 6,
    /**
     * Specifies indicator square shape in a legend
     */
    SquareIndicator = 7,
    /**
     * Specifies marker shape in a legend as long as the series supports markers
     */
    MarkerShape = 8,
    /**
     * Specifies hidden shape without any adjustment to the series title
     */
    HiddenShape = 9
}
/**
 * @hidden
 */
export declare let ActualLegendItemBadgeShape_$type: Type;
