import { Type } from "@infragistics/igniteui-react-core";
/**
 * Describes available locations of the axis labels in the chart.
 */
export declare enum AxisLabelsLocation {
    /**
     * Places the axis labels at the top, outside of the plotting area.
     */
    OutsideTop = 0,
    /**
     * Places the axis labels at the bottom, outside of the plotting area
     */
    OutsideBottom = 1,
    /**
     * Places the axis labels to the left, outside of the plotting area.
     */
    OutsideLeft = 2,
    /**
     * Places the axis labels to the right, outside of the plotting area.
     */
    OutsideRight = 3,
    /**
     * Places the axis labels inside the plotting area above the axis line.
     * CrossingAxis should be set for this setting to take effect.
     */
    InsideTop = 4,
    /**
     * Places the axis labels inside the plotting area below the axis line.
     * CrossingAxis should be set for this setting to take effect.
     */
    InsideBottom = 5,
    /**
     * Places the axis labels inside the plotting area and to the left of the axis line.
     * CrossingAxis should be set for this setting to take effect.
     */
    InsideLeft = 6,
    /**
     * Places the axis labels inside the plotting area and to the right of the axis line.
     * CrossingAxis should be set for this setting to take effect.
     */
    InsideRight = 7
}
/**
 * @hidden
 */
export declare let AxisLabelsLocation_$type: Type;
