import { Type } from "@infragistics/igniteui-react-core";
/**
 * Describes available locations of the axis labels in the chart.
 */
export declare enum AxisRangeBufferMode {
    /**
     * The range buffer mode of the axis is decided automatically.
     */
    Auto = 0,
    /**
     * The range buffer of the axis is defined by the additional requirements of the series to avoid truncating visuals, including visible range margins.
     */
    Series = 1,
    /**
     * The range minimum buffer of the axis is defined by the additional requirements of the series to avoid truncating visuals, including visible range margins.
     */
    SeriesMinimum = 2,
    /**
     * The range maxium buffer of the axis is defined by the additional requirements of the series to avoid truncating visuals, including visible range margins.
     */
    SeriesMaximum = 3,
    /**
     * No extra range buffer should be added.
     */
    None = 4
}
/**
 * @hidden
 */
export declare let AxisRangeBufferMode_$type: Type;
