import { Base, Type, Point } from "@infragistics/igniteui-react-core";
import { IBucketizer } from "./IBucketizer";
import { IFastItemColumn$1 } from "@infragistics/igniteui-react-core";
import { Rect } from "@infragistics/igniteui-react-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ScalerParams } from "./ScalerParams";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { FramePreparer } from "./FramePreparer";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { List$1 } from "@infragistics/igniteui-react-core";
import { ISupportsMarkers } from "./ISupportsMarkers";
import { IProvidesViewport } from "./IProvidesViewport";
import { ISupportsErrorBars } from "./ISupportsErrorBars";
import { CategoryFrame } from "./CategoryFrame";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { PreparationParams } from "./PreparationParams";
import { Frame } from "./Frame";
import { ICategoryScaler } from "./ICategoryScaler";
import { ValuesHolder } from "./ValuesHolder";
import { NumericAxisBase } from "./NumericAxisBase";
import { IHasCategoryTrendline } from "./IHasCategoryTrendline";
import { IHasSingleValueCategory } from "./IHasSingleValueCategory";
import { MarkerSeries } from "./MarkerSeries";
import { IHasCategoryModePreference } from "./IHasCategoryModePreference";
import { ICategorySeriesInteractionManager } from "./ICategorySeriesInteractionManager";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { HighlightingInfo } from "./HighlightingInfo";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { CategoryMode } from "./CategoryMode";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { AssigningCategoryStyleEventArgs } from "./AssigningCategoryStyleEventArgs";
import { AssigningCategoryMarkerStyleEventArgs } from "./AssigningCategoryMarkerStyleEventArgs";
import { SeriesComponentsForView } from "./SeriesComponentsForView";
import { Pool$1 } from "@infragistics/igniteui-react-core";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { RenderSurface } from "./RenderSurface";
import { Clipper } from "@infragistics/igniteui-react-core";
/**
 * @hidden
 */
export declare class CategoryBucketCalculator extends Base implements IBucketizer {
    static $t: Type;
    protected c: CategorySeriesView;
    constructor(a: CategorySeriesView);
    e: number;
    f: number;
    d: number;
    getBucket(a: number): number[];
    getBucketWithoutUnknowns(a: number): number[];
    getErrorBucket(a: number, b: IFastItemColumn$1<number>): number;
    g(a: number): void;
    getBucketInfo(a: number, b: number, c: number, d: number): {
        p0: number;
        p1: number;
        p2: number;
        p3: number;
    };
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare abstract class CategoryFramePreparerBase extends FramePreparer {
    static $t: Type;
    constructor(a: number, b: IIsCategoryBased);
    constructor(a: number, b: IIsCategoryBased, c: ISupportsMarkers, d: IProvidesViewport, e: ISupportsErrorBars, f: IBucketizer);
    constructor(a: number, ..._rest: any[]);
    g: IBucketizer;
    h: IIsCategoryBased;
    protected abstract l(a: CategoryFrame, b: number[], c: IDetectsCollisions, d: number, e: number, f: number): boolean;
    m: boolean;
    private i;
    r(a: ICategoryScaler, b: Rect, c: Rect, d: Rect): number;
    private s;
    d(a: Frame, b: SeriesView): void;
    protected v(a: CategoryFrame, b: SeriesView): void;
    private o;
    protected get q(): List$1<number[]>;
    private p;
    private n;
    protected t(a: PreparationParams, b: ValuesHolder, c: number, d: boolean, e: boolean): number;
    protected k(): boolean;
    protected abstract z(a: ValuesHolder, b: number, c: boolean, d: boolean): void;
    protected abstract u(a: ValuesHolder, b: number, c: boolean): void;
    protected abstract e(a: number, b: ValuesHolder): number[];
    protected f(a: PreparationParams, b: number, c: ValuesHolder, d: number, e: boolean, f: number[], g: number): {
        ret: number[];
        p1?: number;
        p4: boolean;
        p5: number[];
    };
    protected y(a: PreparationParams, b: number, c: boolean, d: ScalerParams, e: ScalerParams, f: boolean, g: boolean): void;
    protected abstract x(a: PreparationParams, b: number[], c: number, d: boolean, e: ScalerParams, f: ScalerParams): void;
    protected w(a: PreparationParams, b: ValuesHolder, c: number): void;
    protected abstract j(a: PreparationParams): ValuesHolder;
}
/**
 * @hidden
 */
export declare class CategoryFramePreparer extends CategoryFramePreparerBase {
    static $t: Type;
    constructor(a: number, b: IIsCategoryBased);
    constructor(a: number, b: IIsCategoryBased, c: ISupportsMarkers, d: IProvidesViewport, e: ISupportsErrorBars, f: IBucketizer);
    constructor(a: number, ..._rest: any[]);
    private aa;
    private ab;
    protected ac: IHasCategoryTrendline;
    protected ad: IHasSingleValueCategory;
    protected l(a: CategoryFrame, b: number[], c: IDetectsCollisions, d: number, e: number, f: number): boolean;
    protected j(a: PreparationParams): ValuesHolder;
    protected x(a: PreparationParams, b: number[], c: number, d: boolean, e: ScalerParams, f: ScalerParams): void;
    protected y(a: PreparationParams, b: number, c: boolean, d: ScalerParams, e: ScalerParams, f: boolean, g: boolean): void;
    protected w(a: PreparationParams, b: ValuesHolder, c: number): void;
    protected z(a: ValuesHolder, b: number, c: boolean, d: boolean): void;
    protected u(a: ValuesHolder, b: number, c: boolean): void;
    protected e(a: number, b: ValuesHolder): number[];
}
/**
 * @hidden
 */
export declare abstract class CategorySeries extends MarkerSeries implements IHasCategoryModePreference, ISupportsErrorBars {
    static $t: Type;
    r2: CategoryFramePreparer;
    protected by(): SeriesView;
    r6: CategorySeriesView;
    private sf;
    get sg(): ICategorySeriesInteractionManager;
    c2(a: List$1<SeriesPointOfInterest>, b: boolean, c: boolean, d: number): boolean;
    private s1;
    l4(a: SeriesView): void;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    get categoryAxis(): CategoryAxisBase;
    rw(): CategoryAxisBase;
    sh(): NumericAxisBase;
    protected get_c7(): boolean;
    protected get_em(): boolean;
    protected get_dj(): boolean;
    constructor();
    ac(): void;
    sn: boolean;
    sm: boolean;
    protected sj: boolean;
    protected si: boolean;
    assigningCategoryStyle: (sender: any, args: AssigningCategoryStyleEventArgs) => void;
    assigningCategoryMarkerStyle: (sender: any, args: AssigningCategoryMarkerStyleEventArgs) => void;
    sp(): boolean;
    protected sq(): boolean;
    protected te(a: AssigningCategoryStyleEventArgs): void;
    protected td(a: AssigningCategoryMarkerStyleEventArgs): void;
    rq(a: number, b: number): any[];
    k2(a: boolean, b: SeriesView): void;
    bi(): SeriesComponentsForView;
    lk(): void;
    ss: boolean;
    protected nb(a: Rect, b: Rect): void;
    r8: CategoryTransitionInMode;
    so: boolean;
    protected na(a: Rect, b: Rect): void;
    protected l9(a: any, b: string, c: any, d: any): void;
    protected sl(): boolean;
    protected sk(): boolean;
    sv(a: Point): number;
    protected get_ec(): boolean;
    as(): CategoryAxisBase;
    hk(a: Point): number;
    abstract getOffsetValue(): number;
    abstract getCategoryWidth(): number;
    hy(a: Point): any;
    hi(a: Point): number;
    f9(a: Point): number;
    private sd;
    private se;
    ay(a: any, b: Point, c: boolean): HighlightingInfo;
    protected get_d0(): boolean;
    k0(): void;
    ax(a: any, b: Point, c: boolean): HighlightingInfo;
    protected su(): List$1<Marker>;
    protected sc(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected sb(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected sa(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    rz: CategoryFrame;
    r1: CategoryFrame;
    rx: CategoryFrame;
    r0: CategoryFrame;
    ry(): CategoryFrame;
    r5: CategorySeriesRenderManager;
    protected ta(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean): void;
    tb(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean): void;
    fd(a: Rect, b: Rect, c: SeriesView): boolean;
    private st;
    protected eu(): boolean;
    protected r7(): CategoryTransitionInMode;
    r9: CategoryTransitionSourceFramePreparer;
    protected k3(): void;
    mo(a: boolean): void;
    protected ca(): TransitionInSpeedType;
    protected sw(): number;
    s0(): number;
    get GetErrorBarsXAxis(): Axis;
    get GetErrorBarsYAxis(): Axis;
    s9(a: CategorySeriesView, b: CategoryFrame): void;
    tf(a: CategoryFrame, b: CategorySeriesView): void;
    tc(a: CategoryFrame, b: CategorySeriesView): void;
    sx(a: SeriesView): number;
    sy(a: SeriesView): number;
    sz(a: SeriesView): number;
    s8(a: SeriesView): void;
    mp(a: Rect, b: RenderSurface): void;
    tg(): void;
    abstract fetchXAxis(): Axis;
    abstract fetchYAxis(): Axis;
    abstract sr(): boolean;
    r3(a: CategorySeriesView): CategoryFramePreparer;
    ao(a: Axis): Axis;
    ag(): Axis[];
    static rr(a: List$1<number[]>, b: number, c: Rect, d: Rect, e: boolean): Clipper;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CategorySeriesView extends MarkerSeriesView implements ISupportsMarkers {
    static $t: Type;
    ct: CategorySeries;
    cw: number;
    cv(a: CategoryFrame): boolean;
    cy(a: CategoryFrame): void;
    constructor(a: CategorySeries);
    updateMarkerTemplate(a: number, b: number, c: number): void;
    cr: CategoryBucketCalculator;
    cs(): CategoryBucketCalculator;
    cu: Pool$1<Marker>;
    get shouldDisplayMarkers(): boolean;
    updateMarkerCount(a: number): void;
    cf(a: (arg1: Marker) => void): void;
    cx(): void;
}
