import { Series } from "./Series";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { Brush } from "@infragistics/igniteui-react-core";
import { IndicatorDisplayType } from "./IndicatorDisplayType";
import { EventArgs, Type } from "@infragistics/igniteui-react-core";
/**
 * @hidden
 */
export interface IIndicatorProxy {
    setXAxis(a: Series, b: CategoryAxisBase): void;
    setYAxis(a: Series, b: NumericYAxis): void;
    setOpenMemberPath(a: Series, b: string): void;
    setHighMemberPath(a: Series, b: string): void;
    setLowMemberPath(a: Series, b: string): void;
    setCloseMemberPath(a: Series, b: string): void;
    setVolumeMemberPath(a: Series, b: string): void;
    setNegativeBrush(a: Series, b: Brush): void;
    setDisplayType(a: Series, b: IndicatorDisplayType): void;
    matchesType(a: Series): boolean;
    setPeriodOverride(a: Series, b: number): void;
    setSmoothingPeriod(a: Series, b: number): void;
    setShortPeriod(a: Series, b: number): void;
    setLongPeriod(a: Series, b: number): void;
    setSignalPeriod(a: Series, b: number): void;
    handleCustomIndicatorEvent(a: Series, b: (sender: any, e: EventArgs) => void): void;
    setMultiplier(a: Series, b: number): void;
}
/**
 * @hidden
 */
export declare let IIndicatorProxy_$type: Type;
