import { Type } from "@infragistics/igniteui-react-core";
/**
 * Describes available modes for displaying empty values in chart legend.
 */
export declare enum LegendEmptyValuesMode {
    /**
     * Always hide legend items for zero values regradless of the Others Category.
     */
    AlwaysHidden = 0,
    /**
     * Always show legend items for zero values even when the Others Category is present.
     */
    AlwaysVisible = 1,
    /**
     * Show legend items for zero values only when the Others Category is not present.
     */
    ShowWhenNoOthersCategory = 2
}
/**
 * @hidden
 */
export declare let LegendEmptyValuesMode_$type: Type;
