import { Type } from "@infragistics/igniteui-react-core";
/**
 * Describes available types of marker than can be displayed by default by series with markers.
 */
export declare enum MarkerType {
    /**
     * Marker hasn't been set.
     */
    Unset = 0,
    /**
     * No marker shapes.
     */
    None = 1,
    /**
     * Automatic marker shape.
     */
    Automatic = 2,
    /**
     * Circle marker shape.
     */
    Circle = 3,
    /**
     * Flat-top triangle marker shape.
     */
    Triangle = 4,
    /**
     * Flat-base triangle marker shape.
     */
    Pyramid = 5,
    /**
     * Square marker shape.
     */
    Square = 6,
    /**
     * Diamond marker shape.
     */
    Diamond = 7,
    /**
     * Pentagon marker shape.
     */
    Pentagon = 8,
    /**
     * Hexagon marker shape.
     */
    Hexagon = 9,
    /**
     * Four-pointed star marker shape.
     */
    Tetragram = 10,
    /**
     * Five-pointed star marker shape.
     */
    Pentagram = 11,
    /**
     * Six-pointed star marker shape.
     */
    Hexagram = 12,
    /**
     * Renders transparent circular markers.
     */
    Hidden = 13
}
/**
 * @hidden
 */
export declare let MarkerType_$type: Type;
