import { Base, Point, Type, EventArgs, INotifyPropertyChanged, IEnumerable, IList, PropertyChangedEventArgs } from "@infragistics/igniteui-react-core";
import { DomRenderer, DomWrapper } from "@infragistics/igniteui-react-core";
import { Rect } from "@infragistics/igniteui-react-core";
import { RenderingContext } from "@infragistics/igniteui-react-core";
import { EventProxy } from "@infragistics/igniteui-react-core";
import { FontInfo } from "@infragistics/igniteui-react-core";
import { PieChartStyleInfo } from "./PieChartStyleInfo";
import { BrushCollection } from "@infragistics/igniteui-react-core";
import { Brush } from "@infragistics/igniteui-react-core";
import { Path } from "@infragistics/igniteui-react-core";
import { PieChartVisualData } from "./PieChartVisualData";
import { Style } from "@infragistics/igniteui-react-core";
import { List$1 } from "@infragistics/igniteui-react-core";
import { Control } from "@infragistics/igniteui-react-core";
import { Line } from "@infragistics/igniteui-react-core";
import { LabelsPosition } from "./LabelsPosition";
import { Visibility } from "@infragistics/igniteui-react-core";
import { LeaderLineType } from "./LeaderLineType";
import { ILegendOwner } from "@infragistics/igniteui-react-core";
import { ILegendSeries } from "@infragistics/igniteui-react-core";
import { ILegendTemplateProvider } from "@infragistics/igniteui-react-core";
import { FastItemsSource } from "@infragistics/igniteui-react-core";
import { DependencyProperty } from "@infragistics/igniteui-react-core";
import { IFastItemColumn$1 } from "@infragistics/igniteui-react-core";
import { UIElement } from "@infragistics/igniteui-react-core";
import { OthersCategoryType } from "./OthersCategoryType";
import { IndexCollection } from "./IndexCollection";
import { NotifyCollectionChangedEventArgs } from "@infragistics/igniteui-react-core";
import { IChartLegend } from "@infragistics/igniteui-react-core";
import { SweepDirection } from "@infragistics/igniteui-react-core";
import { DataTemplate } from "@infragistics/igniteui-react-core";
import { LegendEmptyValuesMode } from "./LegendEmptyValuesMode";
import { SliceSelectionMode } from "./SliceSelectionMode";
import { ObjectCollection } from "@infragistics/igniteui-react-core";
import { BindingFormatter } from "@infragistics/igniteui-react-core";
import { Pool$1 } from "@infragistics/igniteui-react-core";
import { PropertyUpdatedEventArgs } from "@infragistics/igniteui-react-core";
import { SelectedItemChangingEventArgs } from "./SelectedItemChangingEventArgs";
import { SelectedItemsChangingEventArgs } from "./SelectedItemsChangingEventArgs";
import { SelectedItemChangedEventArgs } from "./SelectedItemChangedEventArgs";
import { SelectedItemsChangedEventArgs } from "./SelectedItemsChangedEventArgs";
import { FastItemsSourceEventAction } from "@infragistics/igniteui-react-core";
import { DataContext } from "@infragistics/igniteui-react-core";
import { Size } from "@infragistics/igniteui-react-core";
import { ContentControl } from "@infragistics/igniteui-react-core";
import { PieSliceVisualData } from "./PieSliceVisualData";
import { MouseEventArgs } from "@infragistics/igniteui-react-core";
/**
 * @hidden
 */
export declare class PieChartViewManager extends Base {
    static $t: Type;
    n: DomRenderer;
    protected p: DomWrapper;
    protected s: DomWrapper;
    protected r: DomWrapper;
    protected q: DomWrapper;
    private k;
    private j;
    private l;
    protected ap: Rect;
    e: RenderingContext;
    g: RenderingContext;
    f: RenderingContext;
    h: RenderingContext;
    private a;
    constructor(a: PieChartBaseView);
    aa(): void;
    ad(a: number, b: number): void;
    ae(): void;
    ab(): void;
    z(): void;
    w(a: number, b: number): void;
    ao(): Rect;
    d(): FontInfo;
    an(): Point;
    ah(a: () => void): void;
    b(): PieChartStyleInfo;
    ai(a: Path): void;
    c: EventProxy;
    ac(a: any): void;
    v(a: DomWrapper): void;
    af(a: boolean): void;
    t(): any;
    x(a: PieChartVisualData): void;
    private _toolTipObject;
    private u;
    private i;
    ak(a: any): void;
    aj(pos_: Point, context_: PieSliceDataContext): void;
    y(a: PieSliceDataContext): void;
    al(style_: Style): Brush;
    am(style_: Style): Brush;
    m(style_: Style): number;
    ag(): void;
}
/**
 * @hidden
 */
export declare class LabelClickEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: Slice, b: any);
    private _slice;
    get slice(): Slice;
    set slice(a: Slice);
    get item(): any;
    get allowSliceClick(): boolean;
    set allowSliceClick(a: boolean);
    private c;
}
/**
 * @hidden
 */
export declare class SliceClickEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: Slice, b: any);
    private _slice;
    get slice(): Slice;
    set slice(a: Slice);
    get isSelected(): boolean;
    set isSelected(a: boolean);
    private d;
    get isExploded(): boolean;
    set isExploded(a: boolean);
    private c;
    get isOthersSlice(): boolean;
    get index(): number;
    get dataContext(): any;
    private _originalEvent;
    get originalEvent(): any;
    set originalEvent(a: any);
    get origin(): Point;
    get radius(): number;
    get bounds(): Rect;
    get startAngle(): number;
    get endAngle(): number;
    get fill(): Brush;
    get outline(): Brush;
}
/**
 * @hidden
 */
export declare class SliceEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: Slice, b: any);
    private _slice;
    get slice(): Slice;
    set slice(a: Slice);
    get isSelected(): boolean;
    set isSelected(a: boolean);
    private d;
    get isExploded(): boolean;
    set isExploded(a: boolean);
    private c;
    get isOthersSlice(): boolean;
    get index(): number;
    get origin(): Point;
    get radius(): number;
    get bounds(): Rect;
    get startAngle(): number;
    get endAngle(): number;
    get fill(): Brush;
    get outline(): Brush;
    get dataContext(): any;
    private _originalEvent;
    get originalEvent(): any;
    set originalEvent(a: any);
}
/**
 * @hidden
 */
export declare class PieLabel extends Control {
    static $t: Type;
    constructor();
    ah: Slice;
    ao: Rect;
    ai: number;
    aj: any;
    ap: Line;
    aq: Path;
    ag: LabelsPosition;
    ak(a: PieChartBaseView): void;
    al(): void;
    am(): void;
    an(): void;
}
/**
 * @hidden
 */
export declare abstract class PieChartBase extends Control implements INotifyPropertyChanged, ILegendOwner, ILegendSeries, ILegendTemplateProvider {
    static $t: Type;
    a3(): PieChartBaseView;
    gn(a: PieChartBaseView): void;
    a4: PieChartBaseView;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    constructor();
    private bz;
    private b2;
    private b1;
    private b3;
    private b0;
    private b6;
    private b5;
    private b4;
    private readonly a8;
    private readonly ct;
    private readonly cv;
    private readonly cu;
    private readonly cw;
    private dj;
    bl: FastItemsSource;
    private bp;
    get bu(): IFastItemColumn$1<number>;
    set bu(a: IFastItemColumn$1<number>);
    dl: number;
    dd: number;
    di: number;
    cn: List$1<number>;
    cm: List$1<number>;
    cl: List$1<any>;
    c3: number;
    ck: List$1<UIElement>;
    get c0(): number;
    a7: PieChartSliceSelector;
    private _xsr;
    private get XSRP();
    get d8(): string;
    itemsSource: IEnumerable;
    actualItemsSource: IEnumerable;
    static readonly ho: DependencyProperty;
    get c9(): number;
    set c9(a: number);
    fu: string;
    ei: string;
    ey: string;
    private bn;
    get bq(): IFastItemColumn$1<any>;
    set bq(a: IFastItemColumn$1<any>);
    private bo;
    get br(): IFastItemColumn$1<any>;
    set br(a: IFastItemColumn$1<any>);
    az: LabelsPosition;
    i0: Brush;
    iz: Brush;
    iy: Brush;
    ix: Brush;
    jd: Visibility;
    i9: Style;
    a0: LeaderLineType;
    db: number;
    dq: any;
    dc: number;
    a2: OthersCategoryType;
    e5: string;
    c4: number;
    get cz(): number;
    df: number;
    get c2(): number;
    b8: boolean;
    b7: boolean;
    get explodedSlices(): IndexCollection;
    set explodedSlices(a: IndexCollection);
    private au;
    legend: IChartLegend;
    da: number;
    dh: number;
    i2: SweepDirection;
    get selectedSlices(): IndexCollection;
    set selectedSlices(a: IndexCollection);
    private av;
    ja: Style;
    jb: Style;
    jc: Style;
    am: BrushCollection;
    ak: BrushCollection;
    an: BrushCollection;
    al: BrushCollection;
    ee: string;
    ag: any[];
    e9: string;
    aj: any[];
    ev: string;
    ah: any[];
    e0: string;
    ai: any[];
    legendItemTemplate: DataTemplate;
    legendItemBadgeTemplate: DataTemplate;
    static readonly hz: DependencyProperty;
    get hb(): DataTemplate;
    set hb(a: DataTemplate);
    cd: boolean;
    ce: boolean;
    cg: boolean;
    ch: boolean;
    a1: LegendEmptyValuesMode;
    protected ca(): boolean;
    protected cb(): boolean;
    a5: (obj: any) => string;
    a6: (obj: any) => string;
    private cy;
    get de(): number;
    set de(a: number);
    private cx;
    get c1(): number;
    set c1(a: number);
    bj: SliceSelectionMode;
    get selectedItem(): any;
    set selectedItem(a: any);
    static readonly im: DependencyProperty;
    private _selectedItems;
    get selectedItems(): ObjectCollection;
    set selectedItems(a: ObjectCollection);
    labelClick: (sender: any, e: LabelClickEventArgs) => void;
    gc(a: any, b: LabelClickEventArgs): void;
    selectedItemChanging: (sender: any, e: SelectedItemChangingEventArgs) => void;
    ge(a: any, b: SelectedItemChangingEventArgs): void;
    selectedItemsChanging: (sender: any, e: SelectedItemsChangingEventArgs) => void;
    gh(a: any, b: SelectedItemsChangingEventArgs): void;
    selectedItemChanged: (sender: any, e: SelectedItemChangedEventArgs) => void;
    gd(a: any, b: SelectedItemChangedEventArgs): void;
    selectedItemsChanged: (sender: any, e: SelectedItemsChangedEventArgs) => void;
    gf(a: any, b: SelectedItemsChangedEventArgs): void;
    sliceClick: (sender: any, e: SliceClickEventArgs) => void;
    gj(a: any, b: SliceClickEventArgs): void;
    bw: Pool$1<Slice>;
    bv: Pool$1<PieLabel>;
    fy(a: Slice, b: boolean): void;
    g1(a: Slice, b: boolean): void;
    g2(a: Slice): void;
    dn(a: Slice): any;
    i7(a: Slice, b: LabelsPosition): Rect;
    b9(a: PieLabel, b: Point): boolean;
    static dg(a: number): number;
    private cc;
    private static c5;
    static g7(a: List$1<PieLabel>): void;
    gz(a: List$1<PieLabel>): void;
    protected fw(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    gv(): void;
    go(): void;
    gq(): void;
    private fg;
    gp(): void;
    i8: Rect;
    gy(): void;
    gw(): void;
    private static c6;
    private static i3;
    private static c7;
    private static i4;
    gx(): void;
    bk(): PieChartVisualData;
    d3(): string;
    protected bs(a: string): IFastItemColumn$1<number>;
    protected bt(a: string): IFastItemColumn$1<any>;
    ap: BindingFormatter;
    as: BindingFormatter;
    aq: BindingFormatter;
    ar: BindingFormatter;
    protected gr(a: any, b: string, c: any, d: any): void;
    protected ao(a: BrushCollection): BrushCollection;
    protected i1(a: Brush): Brush;
    private ff;
    private fh;
    private co;
    protected cr(): IEnumerable;
    protected g0(a: NotifyCollectionChangedEventArgs): void;
    protected gg(a: NotifyCollectionChangedEventArgs): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected gt(a: string, b: any, c: any): void;
    private ha;
    private g9;
    g5(a: Slice, b: MouseEventArgs): void;
    g6(a: Slice, b: MouseEventArgs, c: boolean): void;
    g4(a: Point): void;
    cf(a: Slice, b: MouseEventArgs): boolean;
    private dm;
    f0(a: any, b: any): void;
    sliceEnter: (sender: any, e: SliceEventArgs) => void;
    sliceLeave: (sender: any, e: SliceEventArgs) => void;
    sliceHover: (sender: any, e: SliceEventArgs) => void;
    private bf;
    private gk;
    private gl;
    private gm;
    f3(a: any, b: any, c: boolean): void;
    f2(a: any, b: any): void;
    f1(a: any, b: MouseEventArgs): void;
    gi(): void;
    provideContainer(a: any): void;
    ga(a: number, b: number): void;
    notifyContainerResized(): void;
    i6(): Rect;
    i5(): Point;
    destroy(): void;
    fz(): void;
    private dr;
    get fp(): string;
    set fp(a: string);
    get container(): ILegendOwner;
    get isStacked(): boolean;
    get isVertical(): boolean;
    get hasMarkers(): boolean;
    get isUsableInLegend(): boolean;
    get hasSubItems(): boolean;
    c8(a: Slice): number;
    f8(source_: any, a: number, b: any, c: any): void;
    f4(source_: any): void;
    private ci;
    static cj(a: any, b: any): boolean;
    f6(source_: any, a: number, b: any): void;
    f7(source_: any, a: number, b: any): void;
    g3(source_: any): void;
    gu(): void;
    g8(): void;
    bm(): FontInfo;
    resolveLegendIndex(): number;
    forSubItems(a: (arg1: any) => void): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class PieChartSliceSelector extends Base {
    static $t: Type;
    private a;
    constructor(a: PieChartBase);
    d(a: Slice): boolean;
    c(a: Slice): boolean;
    h(a: Slice): any;
    f(a: any, b: boolean): boolean;
    e(a: any): boolean;
    g(a: any): boolean;
    b(a: any): boolean;
    k(a: Slice): void;
    i(a: Slice): void;
    j(a: Slice): void;
}
/**
 * @hidden
 */
export declare class PieSliceOthersContext extends Base {
    static $t: Type;
    private _data;
    get data(): IList;
    set data(a: IList);
    private _slice;
    get slice(): Slice;
    set slice(a: Slice);
}
/**
 * @hidden
 */
export declare class Slice extends ContentControl {
    static $t: Type;
    ak(): SliceView;
    bl(a: SliceView): void;
    al: SliceView;
    constructor();
    a3: number;
    ax: number;
    a1: number;
    a0: number;
    static readonly bv: DependencyProperty;
    get isSelected(): boolean;
    set isSelected(a: boolean);
    static readonly bt: DependencyProperty;
    get isExploded(): boolean;
    set isExploded(a: boolean);
    static readonly bu: DependencyProperty;
    get isOthersSlice(): boolean;
    set isOthersSlice(a: boolean);
    b7: Point;
    b5: Point;
    a2: number;
    ay: number;
    a5: number;
    get b2(): Brush;
    set b2(a: Brush);
    static readonly bp: DependencyProperty;
    a4: number;
    b8: Rect;
    ai: PieChartBase;
    aj: PieLabel;
    bf: string;
    b9: Rect;
    b3: Point;
    aq: boolean;
    au: boolean;
    av: boolean;
    ac(): void;
    az(): number;
    private cb;
    b6(): Point;
    private an;
    get aw(): boolean;
    set aw(a: boolean);
    bk(): void;
    ap(a: Point): boolean;
    private ao;
    private ca;
    am(): PieSliceVisualData;
    private static b4;
    cc: Rect;
    b0: Brush;
    b1: Brush;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class PieChartBaseView extends Base {
    static $t: Type;
    constructor(a: PieChartBase);
    a: PieChartBase;
    a2(): void;
    bc(): void;
    ay(): void;
    a1(): void;
    bt: Brush;
    b: PieChartStyleInfo;
    protected h: RenderingContext;
    j: RenderingContext;
    protected i: RenderingContext;
    protected k: RenderingContext;
    c: PieChartViewManager;
    az(a: any): void;
    b2(): Rect;
    bz(): Point;
    bb(): void;
    b4: Rect;
    private l;
    aw(): void;
    private bj;
    private b1;
    protected a6(): void;
    protected a7(): void;
    private a9;
    private ba;
    private a8;
    private n;
    ak(a: Point, b: boolean, c: boolean): void;
    aj(a: Point): void;
    private by;
    private m;
    ai(a: Point): void;
    al(a: Point): void;
    private aq;
    protected f: Slice;
    private bk;
    o(a: Point): boolean;
    q(a: Point): boolean;
    p(a: Point): boolean;
    private be;
    am(): void;
    bo(a: any, b: any): void;
    protected v: List$1<Slice>;
    g(): Slice;
    bf(a: Slice): void;
    bh(a: Slice): void;
    bg(a: Slice): void;
    protected u: List$1<PieLabel>;
    d(): PieLabel;
    as(a: PieLabel): void;
    au(a: PieLabel): void;
    at(a: PieLabel): void;
    bm(a: PieLabel): void;
    bd(a: Slice): void;
    private bw;
    private bx;
    ae(a: Slice): any;
    z(a: any): number;
    bl(): void;
    w: number;
    y(a: any): number;
    b3(a: PieLabel): Rect;
    b5(): Size;
    bn(a: PieLabel, b: number, c: number): void;
    bq(a: any): void;
    bs(): void;
    av(): void;
    private an;
    a0(a: number, b: number): void;
    ax(): void;
    protected b0: Point;
    protected ah: any;
    protected t: boolean;
    protected e: PieSliceDataContext;
    get ag(): any;
    ar(): void;
    br(a: any): void;
    bp(a: Point, b: any, c: any): void;
    bi(): void;
    a3(): void;
    ad(): any;
    ap(): void;
    s(): boolean;
    ao(a: PieChartVisualData): void;
    r(): boolean;
    a5(): void;
    bu(a: Slice): Brush;
    bv(a: Slice): Brush;
    x(a: Slice): number;
    aa(a: Style): number;
    ab(): number;
    a4(): void;
    af(a: any): any;
}
/**
 * @hidden
 */
export declare class PieSliceDataContext extends DataContext {
    static $t: Type;
    private _slice;
    get slice(): Slice;
    set slice(a: Slice);
    private _percentValue;
    get percentValue(): number;
    set percentValue(a: number);
    private _isOthersSlice;
    get isOthersSlice(): boolean;
    set isOthersSlice(a: boolean);
    flatten(): any;
}
/**
 * @hidden
 */
export declare class SliceView extends Base {
    static $t: Type;
    protected a: Slice;
    constructor(a: Slice);
    g: Path;
    b(): void;
    c(): void;
    f(): Path;
    d(a: number, b: number): void;
    e(): void;
}
