import { Type } from "@infragistics/igniteui-react-core";
/**
 * Describes the highlighting mode to use for the series in the chart.
 */
export declare enum SeriesHighlightingMode {
    /**
     * Highlighting mode is determined by the component.
     */
    Auto = 0,
    /**
     * No highlighting is defined at the chart level. Individual series may have local highlight settings.
     */
    None = 1,
    /**
     * Series will brighten when hovered, and, if applicable brighten indiviudal shapes or markers.
     */
    BrightenSpecific = 2,
    /**
     * Series will brighten when hovered.
     */
    Brighten = 3,
    /**
     * Series will fade if they aren't the hovered series, and, if applicable other shapes in the hovered series will fade.
     */
    FadeOthersSpecific = 4,
    /**
     * Series will fade if they aren't the hovered series, and, if applicable other shapes in the hovered series will fade.
     */
    FadeOthers = 5
}
/**
 * @hidden
 */
export declare let SeriesHighlightingMode_$type: Type;
