import { Type } from "@infragistics/igniteui-react-core";
/**
 * Describes available locations of the axis labels in the chart.
 */
export declare enum SeriesPlotAreaMarginVerticalMode {
    /**
     * Series horizontal plot area margin mode is determined by the component.
     */
    Auto = 0,
    /**
     * The bottom of the horizontal axis will have a plot area margin, if applicable, and the top of the horizontal axis will have a plot area margin, if applicable.
     */
    BottomMarginTopMargin = 1,
    /**
     * The bottom of the horizontal axis will have a range buffer, if applicable, and the top of the horizontal axis will have a range buffer, if applicable.
     */
    BottomBufferTopBuffer = 2,
    /**
     * The bottom of the horizontal axis will have a plot area margin, if applicable, and the top of the horizontal axis will have a range buffer, if applicable.
     */
    BottomMarginTopBuffer = 3,
    /**
     * The bottom of the horizontal axis will have a range buffer, if applicable, and the top of the horizontal axis will have a plot area margin, if applicable.
     */
    BottomBufferTopMargin = 4,
    /**
     * No horizontal contributions to plot area margins will be made.
     */
    None = 5
}
/**
 * @hidden
 */
export declare let SeriesPlotAreaMarginVerticalMode_$type: Type;
