import { Type } from "@infragistics/igniteui-react-core";
/**
 * Describes the scrollbar mode to use for the series viewer.
 */
export declare enum SeriesViewerScrollbarMode {
    /**
     * No horizontal scrollbar will be visible.
     */
    None = 0,
    /**
     * Fading scrollbar will be used that shows only when zoom/pan is changing or the cursor is near.
     */
    Fading = 1,
    /**
     * A scrollbar that faides to a hairline will be used that shows only when zoom/pan is changing or the cursor is near.
     */
    FadeToLine = 2,
    /**
     * Persistent scrollbar will be used that shows all the time.
     */
    Persistent = 3
}
/**
 * @hidden
 */
export declare let SeriesViewerScrollbarMode_$type: Type;
