import { Type } from "@infragistics/igniteui-react-core";
/**
 * Describes available modes for searching for items in the shape series.
 */
export declare enum ShapeItemSearchMode {
    /**
     * Search mode is automatically determined by the component.
     */
    Auto = 0,
    /**
     * When searching for a shape, the shape with the closest bounding box is selected.
     */
    ClosestBoundingBox = 1,
    /**
     * When searching for a shape, the shape with a border closest to the target point is selected.
     * The search is skipped in performance critical scenarios if the number of bounds is over ItemSearchThreshold, or if the number of points in a shape is over ItemSearchPointsThreshold.
     */
    ClosestShape = 2,
    /**
     * When searching for a shape, the closest point along the closest shape is used.
     * The search is skipped in performance critical scenarios if the number of bounds is over ItemSearchThreshold, or if the number of points in a shape is over ItemSearchPointsThreshold.
     */
    ClosestPointOnClosestShape = 3,
    /**
     * No shapes will be searched for the in the shape series.
     */
    None = 4
}
/**
 * @hidden
 */
export declare let ShapeItemSearchMode_$type: Type;
