import { Type } from "@infragistics/igniteui-react-core";
/**
 * Describes available types of speeds used when transitioning in a series.
 */
export declare enum TransitionInSpeedType {
    /**
     * A speed type is automatically selected.
     */
    Auto = 0,
    /**
     * All speeds are normal, data points will arrive at the same time.
     */
    Normal = 1,
    /**
     * Data points will arrive later if their value is further from the start point.
     */
    ValueScaled = 2,
    /**
     * Data points will arrive later if their index is further from the axis origin.
     */
    IndexScaled = 3,
    /**
     * Data points will arrive at random times.
     */
    Random = 4
}
/**
 * @hidden
 */
export declare let TransitionInSpeedType_$type: Type;
