import { Type } from "@infragistics/igniteui-react-core";
/**
 * Describes available locations of the y-axis labels in the chart.
 */
export declare enum YAxisLabelLocation {
    /**
     * Places the y-axis labels to the left, outside of the plotting area.
     */
    OutsideLeft = 0,
    /**
     * Places the y-axis labels to the right, outside of the plotting area.
     */
    OutsideRight = 1,
    /**
     * Places the y-axis labels inside the plotting area and to the left of the axis line.
     * CrossingAxis should be set for this setting to take effect.
     */
    InsideLeft = 2,
    /**
     * Places the y-axis labels inside the plotting area and to the right of the axis line.
     * CrossingAxis should be set for this setting to take effect.
     */
    InsideRight = 3,
    /**
     * Places the y-axis labels based on the type of chart component.
     * Axis Labels Outside Right for Financial Chart and Outside Left for other charts.
     */
    Auto = 4
}
/**
 * @hidden
 */
export declare let YAxisLabelLocation_$type: Type;
