import { IgrFinancialCalculationDataSource } from './igr-financial-calculation-data-source';
import { IgrFinancialCalculationSupportingCalculations } from './igr-financial-calculation-supporting-calculations';
import { FinancialEventArgs as FinancialEventArgs_internal } from "./FinancialEventArgs";
/**
 * Parameterizes a financial calculation event.
*/
export declare class IgrFinancialEventArgs {
    protected _implementation: any;
    get i(): FinancialEventArgs_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    get basedOn(): string[];
    set basedOn(v: string[]);
    /**
 * The beginning position that should be calculated from.
*/
    get position(): number;
    set position(v: number);
    /**
     * The number of positions that should be calculated from the start.
    */
    get count(): number;
    set count(v: number);
    /**
     * The data to use for the calculation.
    */
    get dataSource(): IgrFinancialCalculationDataSource;
    set dataSource(v: IgrFinancialCalculationDataSource);
    /**
     * The supporting calculations to use in the calculation.
    */
    get supportingCalculations(): IgrFinancialCalculationSupportingCalculations;
    set supportingCalculations(v: IgrFinancialCalculationSupportingCalculations);
}
