import * as React from 'react';
import { IgrLegendBase, IIgrLegendBaseProps } from './igr-legend-base';
import { Legend } from "./Legend";
import { FinancialLegend } from './FinancialLegend';
/**
 * Represents a legend that displays information about each series, most often used in financial charting.
*/
export declare class IgrFinancialLegend extends IgrLegendBase<IIgrFinancialLegendProps> {
    private container;
    private _elRef;
    render(): React.DetailedReactHTMLElement<{
        className: string;
        ref: (div: HTMLDivElement) => void;
    }, HTMLDivElement>;
    private _getMainRef;
    componentDidMount(): void;
    private initializeContent;
    constructor(props: IIgrFinancialLegendProps);
    private _wrapper;
    destroy(): void;
    protected createImplementation(): Legend;
    get i(): FinancialLegend;
    /**
 * Gets if the legend is a financial legend.
*/
    get isFinancial(): boolean;
}
export interface IIgrFinancialLegendProps extends IIgrLegendBaseProps {
}
