import * as React from 'react';
import { IgrPieChartBase, IIgrPieChartBaseProps } from './igr-pie-chart-base';
import { XamPieChart } from './XamPieChart';
export declare class IgrPieChart extends IgrPieChartBase<IIgrPieChartProps> {
    private container;
    private _height;
    private _width;
    private _elRef;
    set height(value: string);
    get height(): string;
    set width(value: string);
    get width(): string;
    private _getMainRef;
    render(): React.DetailedReactHTMLElement<{
        className: string;
        ref: (ref: any) => void;
    }, any>;
    constructor(props: IIgrPieChartProps);
    destroy(): void;
    componentDidMount(): void;
    componentWillUnmount(): void;
    private _wrapper;
    protected createImplementation(): XamPieChart;
    get i(): XamPieChart;
    protected createSeriesComponent(type: string): any;
    private _chart;
    private _dataSource;
    set dataSource(value: Array<any>);
    get dataSource(): Array<any>;
    bindData(): void;
    /**
     * Gets or sets the legend used for the current chart.
    */
    get legend(): any;
    set legend(v: any);
}
export interface IIgrPieChartProps extends IIgrPieChartBaseProps {
    width?: string;
    height?: string;
    legend?: any;
    /**
  * Gets or sets the data for the chart to use. This can be overriden at the series and axis level.
  */
    dataSource?: any[];
}
