import { UnknownValuePlotting } from "@infragistics/igniteui-react-core";
import { IgrPolarLineSeriesBase, IIgrPolarLineSeriesBaseProps } from "./igr-polar-line-series-base";
import { PolarAreaSeries } from "./PolarAreaSeries";
/**
 * Represents a IgxDataChartComponent polar area series.
*/
export declare class IgrPolarAreaSeries extends IgrPolarLineSeriesBase<IIgrPolarAreaSeriesProps> {
    protected createImplementation(): PolarAreaSeries;
    /**
                                 * @hidden
                                 */
    get i(): PolarAreaSeries;
    constructor(props: IIgrPolarAreaSeriesProps);
    /**
     * Gets whether the current series shows an area shape.
    */
    get isArea(): boolean;
    /**
     * Determines how unknown values will be plotted on the chart.
     * Null and Double.NaN are two examples of unknown values.
    */
    get unknownValuePlotting(): UnknownValuePlotting;
    set unknownValuePlotting(v: UnknownValuePlotting);
}
export interface IIgrPolarAreaSeriesProps extends IIgrPolarLineSeriesBaseProps {
    /**
     * Determines how unknown values will be plotted on the chart.
     * Null and Double.NaN are two examples of unknown values.
    */
    unknownValuePlotting?: UnknownValuePlotting | string;
}
