import { UnknownValuePlotting } from "@infragistics/igniteui-react-core";
import { IgrAnchoredRadialSeries, IIgrAnchoredRadialSeriesProps } from "./igr-anchored-radial-series";
import { RadialLineSeries } from "./RadialLineSeries";
/**
 * Represents a IgxDataChartComponent radial line series.
*/
export declare class IgrRadialLineSeries extends IgrAnchoredRadialSeries<IIgrRadialLineSeriesProps> {
    protected createImplementation(): RadialLineSeries;
    /**
                                 * @hidden
                                 */
    get i(): RadialLineSeries;
    constructor(props: IIgrRadialLineSeriesProps);
    /**
     * Gets whether the current series shows only line shapes.
    */
    get isLineOnly(): boolean;
    /**
     * Determines how unknown values will be plotted on the chart.
     * Null and Double.NaN are two examples of unknown values.
    */
    get unknownValuePlotting(): UnknownValuePlotting;
    set unknownValuePlotting(v: UnknownValuePlotting);
    /**
     * When overridden in a derived class, is invoked whenever application code or internal processes
     * call ApplyTemplate.
    
    */
    onApplyTemplate(): void;
}
export interface IIgrRadialLineSeriesProps extends IIgrAnchoredRadialSeriesProps {
    /**
     * Determines how unknown values will be plotted on the chart.
     * Null and Double.NaN are two examples of unknown values.
    */
    unknownValuePlotting?: UnknownValuePlotting | string;
}
