import { IgDataTemplate } from "@infragistics/igniteui-react-core";
import { Visibility } from "@infragistics/igniteui-react-core";
import { IgrStyle } from "@infragistics/igniteui-react-core";
import { MarkerType } from "./MarkerType";
import { PenLineCap } from "@infragistics/igniteui-react-core";
import { StackedSeriesCreatedEventArgs as StackedSeriesCreatedEventArgs_internal } from "./StackedSeriesCreatedEventArgs";
import { ContentChildrenManager } from "@infragistics/igniteui-react-core";
/**
 * Provides data for IgxDataChartComponent stacked series.
*/
export declare class IgrStackedSeriesCreatedEventArgs {
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): StackedSeriesCreatedEventArgs_internal;
    private onImplementationCreated;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets or sets the series brush.
    */
    get brush(): string;
    set brush(v: string);
    /**
     * Gets or sets the series legend item template.
    */
    get legendItemTemplate(): IgDataTemplate;
    set legendItemTemplate(v: IgDataTemplate);
    /**
     * Gets or sets the series legend item badge templae.
    */
    get legendItemBadgeTemplate(): IgDataTemplate;
    set legendItemBadgeTemplate(v: IgDataTemplate);
    /**
     * Gets or sets the visibility of the series legend.
    */
    get legendItemVisibility(): Visibility;
    set legendItemVisibility(v: Visibility);
    /**
     * Gets or sets the series outline brush.
    */
    get outline(): string;
    set outline(v: string);
    /**
     * Gets or sets the series stroke dash array.
    */
    get dashArray(): number[];
    set dashArray(v: number[]);
    /**
     * Gets the index of the series.
    */
    get index(): number;
    /**
     * Gets or sets the series outline thickness.
    */
    get thickness(): number;
    set thickness(v: number);
    /**
     * Gets or sets the series title.
    */
    get title(): any;
    set title(v: any);
    /**
     * Gets or sets the animation transition duration for the series.
    */
    get transitionDuration(): number;
    set transitionDuration(v: number);
    /**
     * Gets or sets the animation easing function for the series.
    */
    get transitionEasingFunction(): (time: number) => number;
    set transitionEasingFunction(v: (time: number) => number);
    /**
     * Gets or sets the series marker brush.
    */
    get markerBrush(): string;
    set markerBrush(v: string);
    /**
     * Gets or sets the series marker outline.
    */
    get markerOutline(): string;
    set markerOutline(v: string);
    /**
     * Gets or sets the series marker style.
    */
    get markerStyle(): IgrStyle;
    set markerStyle(v: IgrStyle);
    /**
     * Gets or sets the series marker template.
    */
    get markerTemplate(): IgDataTemplate;
    set markerTemplate(v: IgDataTemplate);
    /**
     * Gets or sets the series marker type.
    */
    get markerType(): MarkerType;
    set markerType(v: MarkerType);
    /**
     * Gets or sets the series marker thickness.
    */
    get markerThickness(): number;
    set markerThickness(v: number);
    get lineCap(): PenLineCap;
    set lineCap(v: PenLineCap);
}
