import { IgrHorizontalStackedSeriesBase, IIgrHorizontalStackedSeriesBaseProps } from "./igr-horizontal-stacked-series-base";
import { StackedSplineAreaSeries } from "./StackedSplineAreaSeries";
/**
 * Represents a IgxDataChartComponent stacked spline area series.
*/
export declare class IgrStackedSplineAreaSeries<P extends IIgrStackedSplineAreaSeriesProps = IIgrStackedSplineAreaSeriesProps> extends IgrHorizontalStackedSeriesBase<P> {
    protected createImplementation(): StackedSplineAreaSeries;
    /**
                                 * @hidden
                                 */
    get i(): StackedSplineAreaSeries;
    constructor(props: P);
    /**
     * Gets or sets whether to include the spline shape in the axis range requested of the axis.
    */
    get isSplineShapePartOfRange(): boolean;
    set isSplineShapePartOfRange(v: boolean);
    /**
     * Gets whether the current series shows an area shape.
    */
    get isArea(): boolean;
    /**
     * Gets whether the current series shows a spline shape.
    */
    get isSpline(): boolean;
}
export interface IIgrStackedSplineAreaSeriesProps extends IIgrHorizontalStackedSeriesBaseProps {
    /**
     * Gets or sets whether to include the spline shape in the axis range requested of the axis.
    */
    isSplineShapePartOfRange?: boolean | string;
}
